#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <opencv2/opencv.hpp>
using namespace cv;
FILE *rfp;

int mode = 0;

struct kyokumen_t {
	char kifu[96];
	char king_pos[2];
};

int rank_num = 150;

//@̎ނ̒萔
#define KOMA_FU		1
#define KOMA_KY		2
#define KOMA_KE		3
#define KOMA_GI		4
#define KOMA_KI		5
#define KOMA_KA		6
#define KOMA_HI		7
#define KOMA_OU		8
#define KOMA_TO		9
#define KOMA_NY		10
#define KOMA_NK		11
#define KOMA_NG		12
#define KOMA_UM		13
#define KOMA_RY		14

#define TE_FROM(te) ((te >> 7) & 0x7f)
#define TE_TO(te)   (te & 0x7f)
#define TE_KOMA(te) ((te >> 15) & 0xf)
#define TE_NARI(te) ((te >> 14) & 1)
#define TE_CAP(te)  ((te >> 19) & 0xf)
// bonanza萔
enum { 
	f_hand_pawn   =    0,
	e_hand_pawn   =   19,
	f_hand_lance  =   38,
	e_hand_lance  =   43,
	f_hand_knight =   48,
	e_hand_knight =   53,
	f_hand_silver =   58,
	e_hand_silver =   63,
	f_hand_gold   =   68,
	e_hand_gold   =   73,
	f_hand_bishop =   78,
	e_hand_bishop =   81,
	f_hand_rook   =   84,
	e_hand_rook   =   87,
	fe_hand_end   =   90,
	f_pawn        =   81,
	e_pawn        =  162,
	f_lance       =  225,
	e_lance       =  306,
	f_knight      =  360,
	e_knight      =  441,
	f_silver      =  504,
	e_silver      =  585,
	f_gold        =  666,
	e_gold        =  747,
	f_bishop      =  828,
	e_bishop      =  909,
	f_horse       =  990,
	e_horse       = 1071,
	f_rook        = 1152,
	e_rook        = 1233,
	f_dragon      = 1314,
	e_dragon      = 1395,
	fe_end        = 1476,
	kkp_hand_pawn   =   0,
	kkp_hand_lance  =  19,
	kkp_hand_knight =  24,
	kkp_hand_silver =  29,
	kkp_hand_gold   =  34,
	kkp_hand_bishop =  39,
	kkp_hand_rook   =  42,
	kkp_hand_end    =  45,
	kkp_pawn        =  36,
	kkp_lance       = 108,
	kkp_knight      = 171,
	kkp_silver      = 252,
	kkp_gold        = 333,
	kkp_bishop      = 414,
	kkp_horse       = 495,
	kkp_rook        = 576,
	kkp_dragon      = 657,
	kkp_end         = 738 
};
enum { pos_n = fe_end * ( fe_end + 1 ) / 2 };
#define nsquare		81
#define Inv(sq)		(nsquare-1-sq)
#define PcPcOnSq(k,i,j)     pc_on_sq[k][(i)*((i)+1)/2+(j)]
#define PcPcOnSq2(k,i,j)    pc_on_sq2[k][(i) * fe_end + j]
#define PcOnSq(k,i)         pc_on_sq2[k][(i) * fe_end + i]

int fkoma[] = {f_pawn, f_lance, f_knight, f_silver, f_gold, f_bishop, f_rook, 0, f_gold, f_gold, f_gold, f_gold, f_horse, f_dragon};
int fkoma_hand[] = {f_hand_pawn, f_hand_lance, f_hand_knight, f_hand_silver, f_hand_gold, f_hand_bishop, f_hand_rook};
int ekoma[] = {e_pawn, e_lance, e_knight, e_silver, e_gold, e_bishop, e_rook, 0, e_gold, e_gold, e_gold, e_gold, e_horse, e_dragon};
int kkp_koma[] = {kkp_pawn, kkp_lance, kkp_knight, kkp_silver, kkp_gold, kkp_bishop, kkp_rook, 0, kkp_gold, kkp_gold, kkp_gold, kkp_gold, kkp_horse, kkp_dragon};
int kkp_handkoma[] = {kkp_hand_pawn, kkp_hand_lance, kkp_hand_knight, kkp_hand_silver, kkp_hand_gold, kkp_hand_bishop, kkp_hand_rook};
short pc_on_sq[2 * nsquare][fe_end*(fe_end+1)/2];
short kkp[nsquare][nsquare][kkp_end];
short pc_on_sq2[nsquare][fe_end*fe_end];



char to_hand[] = {-1, 0, 1, 2, 3, 4, 5, 6, -1, 0, 1, 2, 3, 5, 6};
char to_nari[32] = {
-KOMA_RY,
-KOMA_UM, 
-KOMA_NG,
-KOMA_NK, 
-KOMA_NY, 
-KOMA_TO, 
-KOMA_OU, 
-KOMA_RY, 
-KOMA_UM, 
-KOMA_KI, 
-KOMA_NG, 
-KOMA_NK, 
-KOMA_NY, 
-KOMA_TO, 
0,
KOMA_TO, KOMA_NY, KOMA_NK, KOMA_NG, KOMA_KI, KOMA_UM, KOMA_RY, KOMA_OU, KOMA_TO, KOMA_NY, KOMA_NK, KOMA_NG,KOMA_UM, KOMA_RY
};

char to_unnari[32] = {
-KOMA_HI,
-KOMA_KA, 
-KOMA_GI,
-KOMA_KE, 
-KOMA_KY, 
-KOMA_FU, 
-KOMA_OU, 
-KOMA_RY, 
-KOMA_UM, 
-KOMA_KI, 
-KOMA_NG, 
-KOMA_NK, 
-KOMA_NY, 
-KOMA_TO, 
0,
KOMA_TO, KOMA_NY, KOMA_NK, KOMA_NG, KOMA_KI, KOMA_UM, KOMA_RY, KOMA_OU, KOMA_FU, KOMA_KY, KOMA_KE, KOMA_GI,KOMA_KA, KOMA_HI
};



void print_kifu(char *kifu)
{

	int x, y;
	char name[][3] = {"FU", "KY", "KE", "GI", "KI", "KA", "HI", "OU", "TO", "NY", "NK", "NG", "UM", "RY"};

	printf("   9  8  7  6  5  4  3  2  1\n");
	for(y=0;y<9;y++)
	{
		printf("P%d", y + 1);
		for(x=0;x<9;x++)
		{
			int type      = kifu[y * 9  + x];
			int player;

			if(type > 0)player = 0;
			else player = 1;
			type = abs(type);
			if(type == 0)
			{
				printf(" * ");
			} else 
			{
				if(player == 0)
					printf("+");
				else
					printf("-");
				printf(name[type-1]);
			}
		};//x
		printf("\n");
	};//y

	// 
	int hand, i;
	printf("P+");
	// 
	hand = kifu[81 + 6];
	for(i = 0;i < hand;i++)
		printf("00HI");
	// p
	hand = kifu[81 + 5];
	for(i = 0;i < hand;i++)
		printf("00KA");
	// 
	hand = kifu[81 + 4];
	for(i = 0;i < hand;i++)
		printf("00KI");
	// 
	hand = kifu[81 + 3];
	for(i = 0;i < hand;i++)
		printf("00GI");
	// j
	hand = kifu[81 + 2];
	for(i = 0;i < hand;i++)
		printf("00KE");
	// 
	hand = kifu[81 + 1];
	for(i = 0;i < hand;i++)
		printf("00KY");
	// 
	hand = kifu[81 + 0];
	for(i = 0;i < hand;i++)
		printf("00FU");
	printf("\n");

	printf("P-");
	// 
	hand = kifu[88 + 6];
	for(i = 0;i < hand;i++)
		printf("00HI");
	// p
	hand = kifu[88 + 5];
	for(i = 0;i < hand;i++)
		printf("00KA");
	// 
	hand = kifu[88 + 4];
	for(i = 0;i < hand;i++)
		printf("00KI");
	// 
	hand = kifu[88 + 3];
	for(i = 0;i < hand;i++)
		printf("00GI");
	// j
	hand = kifu[88 + 2];
	for(i = 0;i < hand;i++)
		printf("00KE");
	// 
	hand = kifu[88 + 1];
	for(i = 0;i < hand;i++)
		printf("00KY");
	// 
	hand = kifu[88 + 0];
	for(i = 0;i < hand;i++)
		printf("00FU");
	printf("\n");

}

IplImage *img_koma[14];

void load_koma(){
	img_koma[1] = cvLoadImage("./img/FU.jpg");
	img_koma[2] = cvLoadImage("./img/KY.jpg");
	img_koma[3] = cvLoadImage("./img/KE.jpg");
	img_koma[4] = cvLoadImage("./img/GI.jpg");
	img_koma[5] = cvLoadImage("./img/KI.jpg");
	img_koma[6] = cvLoadImage("./img/KA.jpg");
	img_koma[7] = cvLoadImage("./img/HI.jpg");
	img_koma[8] = cvLoadImage("./img/OU.jpg");
	img_koma[9] = cvLoadImage("./img/TO.jpg");
	img_koma[10] = cvLoadImage("./img/NY.jpg");
	img_koma[11] = cvLoadImage("./img/NK.jpg");
	img_koma[12] = cvLoadImage("./img/NG.jpg");
	img_koma[13] = cvLoadImage("./img/UM.jpg");
	img_koma[14] = cvLoadImage("./img/RY.jpg");	
}

void get_pos(int p, int &dx, int &dy){
	int bx, by;
	bx = 50;
	by = 80;
	int tw, th;
	tw = 45;
	th = 50;
	int x, y;
	if(p < 81){
		x = p % 9;
		y = p / 9;
		dx = bx + x * tw + tw * 0.5;
		dy = by + y * th + th * 0.5;
	} else {

		if(p >= 88){
			dy = 10 + tw*0.5;
			dx = 10 + (p-88)*tw + th * 0.5;
		} else {
			dy = by + th * 10 + tw*0.5;
			dx = 10 + (p-81)*tw + th*0.5;
		}
	}
}
void paste_img(IplImage * tmp, IplImage * out, int dx, int dy, int player){

	int w, h;
	w = tmp->widthStep;
	h = tmp->height;
	if(player == 0){
		for(int y = 0;y < h;y++){
			for(int x = 0;x < tmp->width;x++){
				for(int i = 0;i < 3;i++){
					out->imageData[i + 3*(x + dx) + (dy + y) * out->widthStep] = tmp->imageData[3 * x + i + y * w];
				}
			}
		}
	} else {
		for(int y = 0;y < h;y++){
			for(int x = 0;x < tmp->width;x++){
				for(int i = 0;i < 3;i++){
					out->imageData[i + 3*(x + dx) + (dy + y) * out->widthStep] = tmp->imageData[3 * (tmp->width-1-x) + i + (tmp->height-1-y) * w];
				}
			}
		}
	}
}

void draw_kifu(char *kifu,  IplImage *img){

	load_koma();

	int bx, by;
	bx = 50;
	by = 80;
	int tw, th;
	tw = 45;
	th = 50;
	cvRectangle(img, cvPoint(0,0), cvPoint(img->width, img->height), cvScalar(0,0,0), -1);

	for(int y = 0;y < 9;y++){
		for(int x = 0;x < 9;x++){
			int koma = kifu[x + y * 9];
			int dx, dy;
			dx = x * tw + bx;
			dy = y * th + by; 
			if(koma){
				if(koma > 0){
					paste_img(img_koma[koma], img, dx, dy, 0);
				} else {
					paste_img(img_koma[-koma], img, dx, dy, 1);
				}
			}
		}
	}
    CvFont dfont;
    float hscale      = 0.4f;
    float vscale      = 0.4f;
    float italicscale = 0.4f;
    int  thickness    = 1;
    cvInitFont (&dfont, CV_FONT_HERSHEY_SIMPLEX , hscale, vscale, italicscale, thickness, CV_AA);

	char buf[256];
	for(int i = 0;i < 7;i++){
		int dx, dy;
		if(kifu[81+i] > 0){
			dx = i * 45 + 10;
			dy = by + 10 * th;
			paste_img(img_koma[1 + i], img, dx, dy, 0);
			sprintf(buf, "x%d", kifu[81+i]);
			cvPutText(img, buf, cvPoint(dx+8, dy+3), &dfont, CV_RGB(255, 255, 255));
		}
		if(kifu[88+i] > 0){
			dx = i * 45 + 10;
			dy = 10;
			paste_img(img_koma[1 + i], img, dx, dy, 1);
			sprintf(buf, "x%d", kifu[88+i]);
			cvPutText(img, buf, cvPoint(dx+8, dy+3), &dfont, CV_RGB(255, 255, 255));
		}
	}

	for(int y = 0;y <= 9;y++){
		cvLine(img, cvPoint(bx,         by + y * th), cvPoint(bx + tw * 9, by + y * th), cvScalar(255,255,255), 1);
		cvLine(img, cvPoint(bx +y * tw, by         ), cvPoint(bx + y * tw, by + th * 9), cvScalar(255,255,255), 1);
	}

}


void draw_rank(char *file, char *kifu, int value, int p1, int p2, int p3){

	IplImage *pimg;
	pimg   = cvCreateImage(cvSize(640,640), IPL_DEPTH_8U, 3);	
	draw_kifu(kifu, pimg);
	int r, g, b;

	if(value < 0){
		r = 0;
		g = 0;
		b = 128 + value / 32;
		if(b > 255)b=255;
	} else {
		b = 0;
		g = 0;
		r = 128 + value / 32;
		if(r > 255)r=255;
	}
	int bx, by;
	bx = 50;
	by = 80;
	int tw, th;
	tw = 45;
	th = 50;
	int dx1, dy1;
	int dx2, dy2;
	int dx3, dy3;
	int x, y;

	get_pos(p1,dx1,dy1);
	get_pos(p2,dx2,dy2);
	get_pos(p3,dx3,dy3);
	/*
	x = p1 % 9;
	y = p1 / 9;
	dx1 = bx + x * tw + tw * 0.5;
	dy1 = by + y * th + th * 0.5;
	x = p2 % 9;
	y = p2 / 9;
	dx2 = bx + x * tw + tw * 0.5;
	dy2 = by + y * th + th * 0.5;
	x = p3 % 9;
	y = p3 / 9;
	dx3 = bx + x * tw + tw * 0.5;
	dy3 = by + y * th + th * 0.5;
	*/

	cvLine(pimg, cvPoint(dx1,dy1), cvPoint(dx2,dy2), cvScalar(r,g,b),3);
	cvLine(pimg, cvPoint(dx2,dy2), cvPoint(dx3,dy3), cvScalar(r,g,b),3);
	cvLine(pimg, cvPoint(dx3,dy3), cvPoint(dx1,dy1), cvScalar(r,g,b),3);

	cvCircle(pimg, cvPoint(dx1, dy1), 10, cvScalar(r, g,b), -1);
	cvCircle(pimg, cvPoint(dx2, dy2), 10, cvScalar(r, g,b), -1);
	cvCircle(pimg, cvPoint(dx3, dy3), 10, cvScalar(r, g,b), -1);


    CvFont dfont;
    float hscale      = 1.4f;
    float vscale      = 1.4f;
    float italicscale = 1.4f;
    int  thickness    = 2;
    cvInitFont (&dfont, CV_FONT_HERSHEY_SIMPLEX , hscale, vscale, italicscale, thickness, CV_AA);

	char buf[256];
	sprintf(buf, "%+d", value/32);
	int dx, dy;
	dx = (dx1+dx2+dx3)/3 - 50;
	dy = (dy1+dy2+dy3)/3 + 20;
	cvPutText(pimg, buf, cvPoint(dx+2, dy+2), &dfont, cvScalar(255,255, 255));
	cvPutText(pimg, buf, cvPoint(dx-2, dy-2), &dfont, cvScalar(255,255, 255));
	cvPutText(pimg, buf, cvPoint(dx-2, dy+2), &dfont, cvScalar(255,255, 255));
	cvPutText(pimg, buf, cvPoint(dx+2, dy-2), &dfont, cvScalar(255,255, 255));
	cvPutText(pimg, buf, cvPoint(dx, dy), &dfont, cvScalar(r,g, b));



	cvSaveImage(file, pimg);

}


// i߂
void make_move(int player, kyokumen_t * kyokumen, int & te)
{

	int from = TE_FROM(te);
	int   to = TE_TO(te);

	// ړ
	if(from < 81)
	{
		int to_koma   = kyokumen->kifu[to];
		int from_koma = kyokumen->kifu[from];

		if(TE_NARI(te))
		{
			// ړXV
			kyokumen->kifu[to]       = to_nari[from_koma + 14];
		}
		else {
			// ړXV
			kyokumen->kifu[to]       = kyokumen->kifu[from];
		}
		// ړXV
		kyokumen->kifu[from] = 0;

		// 
		if(to_koma)
		{
			int take = to_hand[abs(to_koma)];
			te |= (abs(to_koma) << 19);
			if(take >= 0)
			{
				if(player == 0)
				{
					kyokumen->kifu[81 + take]++;
				}
				else 
				{
					kyokumen->kifu[88 + take]++;
				}
			}
		}

		// ̈ړ̏ꍇ
		if(abs(kyokumen->kifu[to]) == KOMA_OU)
		{
			kyokumen->king_pos[player] = to;
		}
	} else {
		// u
		int drop = from  - 81;
		if(player == 0)
		{
			kyokumen->kifu[81 + drop]--;

			kyokumen->kifu[to]   = drop + 1;
		}
		else {
			kyokumen->kifu[88 + drop]--;


			kyokumen->kifu[to]   = -drop - 1;
		}
	};

};

// ߂
void unmake_move(int player, kyokumen_t * kyokumen, int & te)
{

	int from = TE_FROM(te);
	int   to = TE_TO(te);
	// ړ
	if(from < 81)
	{
		int to_koma   = kyokumen->kifu[to];
		int from_koma = kyokumen->kifu[from];

		if(TE_NARI(te))
		{

			// ړXV
			kyokumen->kifu[from]     = to_unnari[to_koma + 14];
		}
		else {
			// ړXV
			kyokumen->kifu[from]     = kyokumen->kifu[to];
		}

		// 
		if(TE_CAP(te))
		{
			int take = to_hand[TE_CAP(te)];

			if(take >= 0)
			{
				if(player == 0)
				{
					// ړXV
					kyokumen->kifu[to] = -TE_CAP(te);

					kyokumen->kifu[81 + take]--;
				}
				else 
				{
					// ړXV
					kyokumen->kifu[to] =  TE_CAP(te);

					kyokumen->kifu[88 + take]--;

				}
			} else {
				if(player == 0)
				{
					// ړXV
					kyokumen->kifu[to] = -TE_CAP(te);

				}
				else 
				{
					// ړXV
					kyokumen->kifu[to] =  TE_CAP(te);

				}
			};
			te &= 0x7ffff;
		} else 
		{
			// ړXV
			kyokumen->kifu[to] = 0;
		};

		// ̈ړ̏ꍇ
		if(abs(kyokumen->kifu[from]) == KOMA_OU)
		{
			kyokumen->king_pos[player] = from;
		}


	} else {
		// u
		int drop = from  - 81;
		if(player == 0)
		{
			kyokumen->kifu[81 + drop]++;


			kyokumen->kifu[to]  = 0;

		}
		else {
			kyokumen->kifu[88 + drop]++;

			kyokumen->kifu[to]  = 0;
		}
	};
};

struct rank_t {
	short value;
	short p1, p2, p3;
	bool operator < (const rank_t & ref) const {
		if(mode == 0)
			return abs(ref.value) < abs(value);
		else if(mode == 1)
			return (ref.value) < (value);
		return (ref.value) > (value);
	}
};

char *koma_name(int pos, int koma){
	static char buf[1024];
	char name[][3] = {"", "FU", "KY", "KE", "GI", "KI", "KA", "HI", "OU", "TO", "NY", "NK", "NG", "UM", "RY"};

	int p = 0;

	if(pos > 80){
		if(pos >= 88){
			sprintf(buf, "-%s*", name[pos-88+1]);
		} else {
			sprintf(buf, "+%s*", name[pos-81+1]);
		}

	} else {
	if(koma < 0){p=1;koma = -koma;}

	int x, y;
	x = 8 - pos % 9 + 1;
	y = pos / 9 + 1;
	if(p==0)
		sprintf(buf, "+%d%d%s", x, y, name[koma]);
	else
		sprintf(buf, "-%d%d%s", x, y, name[koma]);
	}
	return buf;
}
#define V_FU	87
#define V_KY	232
#define V_KE	257
#define V_GI	369
#define V_KI	444
#define V_KA	569
#define V_HI	642
#define V_OU	15000
#define V_TO	534
#define V_NY	488
#define V_NK	519
#define V_NG	485
#define V_UM	827
#define V_RY	945

int koma_value[] =
{
	-V_RY, //0
	-V_UM, //1
	-V_NG, //2
	-V_NK, //3
	-V_NY, //4
	-V_TO, //5
	-V_OU, //6
	-V_HI, //7
	-V_KA, //8
	-V_KI, //9
	-V_GI, //10
	-V_KE, //11
	-V_KY, //12
	-V_FU, //13
	    0, //14
  	 V_FU, //15
	 V_KY, 
	 V_KE, 
	 V_GI, 
	 V_KI, 
	 V_KA, 
	 V_HI, 
	 V_OU, 
	 V_TO, 
	 V_NY, 
	 V_NK, 
	 V_NG, 
	 V_UM, 
	 V_RY
};
#include <math.h>

void add_hist(int *h1, int *h2, int v){

	int index;
	if(v > 0){
		v = v / 32;
		index = floor(v / 10.0);
		if(index > 7)index = 7;
		h1[index]++;
	} else if(v < 0){
		v = -v / 32;
		index = floor(v / 10.0);
		if(index > 7)index = 7;
		h2[index]++;
	}
};



// vZ
int material(kyokumen_t & in){
	int mat = 0;
	int pos;

	for(pos = 0;pos < 81;pos++)
		mat += koma_value[in.kifu[pos] + 14];
	// 
	for(int i = 0;i < 7;i++)
		mat += koma_value[15 + i] * (in.kifu[81 + i] - in.kifu[88 + i]);

	return mat;
}

int evaluate_pos(kyokumen_t & in, int ply)
{

	IplImage *pimg;
	pimg   = cvCreateImage(cvSize(640,640), IPL_DEPTH_8U, 3);	
	draw_kifu(in.kifu, pimg);
	cvSaveImage("./log/leaf.png", pimg);

	int ret  = 0;
	int sq_bk0, sq_wk0;
	int sq_bk1, sq_wk1;
	unsigned short list0[52];
	unsigned short list1[52];
	unsigned short plist0[52];
	unsigned short plist1[52];
	int nlist, nplist;

	sq_bk0 = in.king_pos[0];
	sq_wk0 = in.king_pos[1];
	sq_bk1 = Inv(in.king_pos[1]);
	sq_wk1 = Inv(in.king_pos[0]);

	nlist = 0;

	list0[nlist]   = f_hand_pawn   + in.kifu[81 + 0];
	list1[nlist++] = f_hand_pawn   + in.kifu[88 + 0];

	list0[nlist]   = e_hand_pawn   + in.kifu[88 + 0];
	list1[nlist++] = e_hand_pawn   +	in.kifu[81 + 0];

	list0[nlist]   = f_hand_lance  + in.kifu[81 + 1];
	list1[nlist++] = f_hand_lance  +	in.kifu[88 + 1];

	list0[nlist]   = e_hand_lance  + in.kifu[88 + 1];
	list1[nlist++] = e_hand_lance  +	in.kifu[81 + 1];

	list0[nlist]   = f_hand_knight + in.kifu[81 + 2];
	list1[nlist++] = f_hand_knight +	in.kifu[88 + 2];

	list0[nlist]   = e_hand_knight + in.kifu[88 + 2];
	list1[nlist++] = e_hand_knight +	in.kifu[81 + 2];

	list0[nlist]   = f_hand_silver + in.kifu[81 + 3];
	list1[nlist++] = f_hand_silver +	in.kifu[88 + 3];

	list0[nlist]   = e_hand_silver + in.kifu[88 + 3];
	list1[nlist++] = e_hand_silver +	in.kifu[81 + 3];

	list0[nlist]   = f_hand_gold   + in.kifu[81 + 4];
	list1[nlist++] = f_hand_gold   +	in.kifu[88 + 4];

	list0[nlist]   = e_hand_gold   + in.kifu[88 + 4];
	list1[nlist++] = e_hand_gold   +	in.kifu[81 + 4];

	list0[nlist]   = f_hand_bishop + in.kifu[81 + 5];
	list1[nlist++] = f_hand_bishop +	in.kifu[88 + 5];

	list0[nlist]   = e_hand_bishop + in.kifu[88 + 5];
	list1[nlist++] = e_hand_bishop +	in.kifu[81 + 5];

	list0[nlist]   = f_hand_rook   + in.kifu[81 + 6];
	list1[nlist++] = f_hand_rook   +	in.kifu[88 + 6];

	list0[nlist]   = e_hand_rook   + in.kifu[88 + 6];
	list1[nlist++] = e_hand_rook   +	in.kifu[81 + 6];

	nplist = 0;

	plist0[nplist]   = 81;
	plist1[nplist++] = 88;
	plist0[nplist]   = 88;
	plist1[nplist++] = 81;

	plist0[nplist]   = 82;
	plist1[nplist++] = 89;
	plist0[nplist]   = 89;
	plist1[nplist++] = 82;

	plist0[nplist]   = 83;
	plist1[nplist++] = 90;
	plist0[nplist]   = 90;
	plist1[nplist++] = 83;

	plist0[nplist]   = 84;
	plist1[nplist++] = 91;
	plist0[nplist]   = 91;
	plist1[nplist++] = 84;

	plist0[nplist]   = 85;
	plist1[nplist++] = 92;
	plist0[nplist]   = 92;
	plist1[nplist++] = 85;

	plist0[nplist]   = 86;
	plist1[nplist++] = 93;
	plist0[nplist]   = 93;
	plist1[nplist++] = 86;

	plist0[nplist]   = 87;
	plist1[nplist++] = 94;
	plist0[nplist]   = 94;
	plist1[nplist++] = 87;



	for(int pos = 0;pos < 81;pos++)
	{
		char koma = in.kifu[pos];
		switch(koma)
		{
		case KOMA_FU:
			ret = ret + kkp[sq_bk0][sq_wk0][kkp_pawn + pos];
			list0[nlist]   = f_pawn + pos;
			list1[nlist++] = e_pawn + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;
		case -KOMA_FU:
			ret = ret - kkp[sq_bk1][sq_wk1][kkp_pawn + Inv(pos)];
			list0[nlist]   = e_pawn + pos;
			list1[nlist++] = f_pawn + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case KOMA_KY:
			ret = ret + kkp[sq_bk0][sq_wk0][kkp_lance + pos];
			list0[nlist]   = f_lance + pos;
			list1[nlist++] = e_lance + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;
		case -KOMA_KY:
			ret = ret - kkp[sq_bk1][sq_wk1][kkp_lance + Inv(pos)];
			list0[nlist]   = e_lance + pos;
			list1[nlist++] = f_lance + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case KOMA_KE:
			ret = ret + kkp[sq_bk0][sq_wk0][kkp_knight + pos];
			list0[nlist]   = f_knight + pos;
			list1[nlist++] = e_knight + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case -KOMA_KE:
			ret = ret - kkp[sq_bk1][sq_wk1][kkp_knight + Inv(pos)];
			list0[nlist]   = e_knight + pos;
			list1[nlist++] = f_knight + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case KOMA_GI:
			ret = ret + kkp[sq_bk0][sq_wk0][kkp_silver+ pos];
			list0[nlist]   = f_silver + pos;
			list1[nlist++] = e_silver + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case -KOMA_GI:
			ret = ret - kkp[sq_bk1][sq_wk1][kkp_silver + Inv(pos)];
			list0[nlist]    = e_silver + pos;
			list1[nlist++]  = f_silver + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case KOMA_KI:
		case KOMA_TO:
		case KOMA_NY:
		case KOMA_NK:
		case KOMA_NG:
			ret = ret + kkp[sq_bk0][sq_wk0][kkp_gold + pos];
			list0[nlist]   = f_gold + pos;
			list1[nlist++] = e_gold + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;
		case -KOMA_KI:
		case -KOMA_TO:
		case -KOMA_NY:
		case -KOMA_NK:
		case -KOMA_NG:
			ret = ret - kkp[sq_bk1][sq_wk1][kkp_gold + Inv(pos)];
			list0[nlist]   = e_gold + pos;
			list1[nlist++] = f_gold + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case KOMA_HI:
			ret = ret + kkp[sq_bk0][sq_wk0][kkp_rook + pos];
			list0[nlist]   = f_rook + pos;
			list1[nlist++] = e_rook + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;
		case -KOMA_HI:
			ret = ret - kkp[sq_bk1][sq_wk1][kkp_rook + Inv(pos)];
			list0[nlist]   = e_rook + pos;
			list1[nlist++] = f_rook + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case KOMA_RY:
			ret = ret + kkp[sq_bk0][sq_wk0][kkp_dragon + pos];
			list0[nlist]   = f_dragon + pos;
			list1[nlist++] = e_dragon + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;
		case -KOMA_RY:
			ret = ret - kkp[sq_bk1][sq_wk1][kkp_dragon + Inv(pos)];
			list0[nlist]   = e_dragon + pos;
			list1[nlist++] = f_dragon + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case KOMA_KA:
			ret = ret + kkp[sq_bk0][sq_wk0][kkp_bishop + pos];
			list0[nlist]   = f_bishop + pos;
			list1[nlist++] = e_bishop + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;
		case -KOMA_KA:
			ret = ret - kkp[sq_bk1][sq_wk1][kkp_bishop + Inv(pos)];
			list0[nlist]   = e_bishop + pos;
			list1[nlist++] = f_bishop + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;

		case KOMA_UM:
			ret = ret + kkp[sq_bk0][sq_wk0][kkp_horse + pos];
			list0[nlist]   = f_horse + pos;
			list1[nlist++] = e_horse + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;
		case -KOMA_UM:
			ret = ret - kkp[sq_bk1][sq_wk1][kkp_horse + Inv(pos)];
			list0[nlist]   = e_horse + pos;
			list1[nlist++] = f_horse + Inv(pos);
			plist0[nplist]   = pos;
			plist1[nplist++] = pos;
			break;
		};
	};

	// hand
	ret += kkp[sq_bk0][sq_wk0][ kkp_hand_pawn   + in.kifu[81 + 0]];
	ret += kkp[sq_bk0][sq_wk0][ kkp_hand_lance  + in.kifu[81 + 1]];
	ret += kkp[sq_bk0][sq_wk0][ kkp_hand_knight + in.kifu[81 + 2]];
	ret += kkp[sq_bk0][sq_wk0][ kkp_hand_silver + in.kifu[81 + 3]];
	ret += kkp[sq_bk0][sq_wk0][ kkp_hand_gold   + in.kifu[81 + 4]];
	ret += kkp[sq_bk0][sq_wk0][ kkp_hand_bishop + in.kifu[81 + 5]];
	ret += kkp[sq_bk0][sq_wk0][ kkp_hand_rook   + in.kifu[81 + 6]];

	ret -= kkp[sq_bk1][sq_wk1][ kkp_hand_pawn   + in.kifu[88 + 0]];
	ret -= kkp[sq_bk1][sq_wk1][ kkp_hand_lance  + in.kifu[88 + 1]];
	ret -= kkp[sq_bk1][sq_wk1][ kkp_hand_knight + in.kifu[88 + 2]];
	ret -= kkp[sq_bk1][sq_wk1][ kkp_hand_silver + in.kifu[88 + 3]];
	ret -= kkp[sq_bk1][sq_wk1][ kkp_hand_gold   + in.kifu[88 + 4]];
	ret -= kkp[sq_bk1][sq_wk1][ kkp_hand_bishop + in.kifu[88 + 5]];
	ret -= kkp[sq_bk1][sq_wk1][ kkp_hand_rook   + in.kifu[88 + 6]];

	printf("KKP=%d\n", ret);
	// KPPZ
	int sum;
	sum = 0;


	int k0,k1,l0,l1;
	int pn, nn, pv, nv;
	pn = nn = pv = nv = 0;

	int h1[8] = {0}, h2[8] = {0};
	rank_t ranks[4096];
	int ranks_num = 0;
	// KPPZ
	for (int i = 0; i < nlist; i++ )
	{
		k0 = list0[i];
		k1 = list1[i];
		for (int j = 0; j <= i; j++ )
		{
			l0 = list0[j];
			l1 = list1[j];
			int p1, p2;
			p1 = PcPcOnSq2( sq_bk0, k0, l0 );
			p2 = PcPcOnSq2( sq_bk1, k1, l1 );
			sum += p1;
			sum -= p2;
			if(p1 > 0){
				pn++;
				pv+=p1;
			} else {
				nn++;
				nv-=p1;
			}
			if(p2 > 0){
				pn++;
				nv += p2;
			} else {
				nn++;
				pv -= p2;
			}

			ranks[ranks_num].p1 = in.king_pos[0];
			ranks[ranks_num].p2 = plist0[i];
			ranks[ranks_num].p3 = plist0[j];
			ranks[ranks_num++].value = p1;

			ranks[ranks_num].p1 = in.king_pos[1];
			ranks[ranks_num].p2 = plist1[i];
			ranks[ranks_num].p3 = plist1[j];
			ranks[ranks_num++].value = -p2;

			add_hist(h1,h2,  p1);
			add_hist(h1,h2, -p2);
		}
	}
	pv /= 32;
	nv /= 32;

	printf("KPP=%d\n", sum / 32);

	printf("L=%d, a=%d\nz\n", pn, pv);
	fprintf(rfp, "L=%d, a=%d<br>", pn, pv);
	for(int i = 0;i < 8;i++){
		printf(" [%d`%d] = %d\n", i*10, (i+1)*10, h1[i]);
		fprintf(rfp, " [%d`%d] = %d<br>", i*10, (i+1)*10, h1[i]);
	}
	printf("L=%dCa=%d\nz\n", nn, nv);
	fprintf(rfp, "L=%dCa=%d<br>", nn, nv);
	for(int i = 0;i < 8;i++){
		printf(" [%d`%d] = %d\n", i*10, (i+1)*10, h2[i]);
		fprintf(rfp, " [%d`%d] = %d<br>", i*10, (i+1)*10, h2[i]);
	}
	std::sort(&ranks[0], &ranks[ranks_num]);
	printf("RANKING:\n");
	for(int i = 0;i < rank_num;i++){
		int p1, p2, p3;
		int k1, k2, k3;
		int value = ranks[i].value;
		p1 = ranks[i].p1;
		p2 = ranks[i].p2;
		p3 = ranks[i].p3;
		k1 = in.kifu[p1];
		k2 = in.kifu[p2];
		k3 = in.kifu[p3];
		printf("%d: value = %d  ", i + 1, value);
		printf("[%s]-",  koma_name(p1, k1));
		printf("[%s]-",  koma_name(p2, k2));
		printf("[%s]\n", koma_name(p3, k3));
		
		char file[256];
		sprintf(file, "./log/rank%03d.png", i+1);
		draw_rank(file, in.kifu, value, p1, p2, p3);
	}

	int mat = material(in);
	return (32 * mat+ret + sum)/32;	// KKP +KPP

};

void load_fv(char *filename)
{
	unsigned int size;

	FILE *fp;
	fp=fopen(filename, "rb");

	size = nsquare * pos_n;
	// ǂݍ
	fread( pc_on_sq, sizeof(short), size, fp );
	size = nsquare * nsquare * kkp_end;
	fread( kkp, sizeof(short), size, fp);
	fclose(fp);


	// Ώ̉
	float sum = 0, asum = 0;
	int k, j, i;
	for(k = 0;k < 81;k++)
	{
		for(i = 0;i < fe_end;i++)
		{
			for(j = 0;j < fe_end;j++)
			{
				if(j <= i)
				{
					PcPcOnSq2(k, i, j) = PcPcOnSq(k, i, j);
				} else {
					PcPcOnSq2(k, i, j) = PcPcOnSq(k, j, i);
				}
				sum += PcPcOnSq2(k, i, j);
				asum += abs(PcPcOnSq2(k, i, j));
			};
		};
	};
};

void load_csa(char *filename, kyokumen_t & out){

	FILE *fp=fopen(filename, "r");
	char name[][3] = {"FU", "KY", "KE", "GI", "KI", "KA", "HI", "OU", "TO", "NY", "NK", "NG", "UM", "RY"};

	if(fp){
		char buf[1024];
		fgets(buf, 1024, fp);
		fgets(buf, 1024, fp);
		fgets(buf, 1024, fp);

		memset(out.kifu, 0, 95);
		for(int y = 0;y < 9;y++){
			fgets(buf, 1024, fp);
			for(int x = 0;x < 9;x++){
				char c1, c2, c3;
				int sign = 0;
				c1 = buf[2 + x * 3];
				c2 = buf[2 + x * 3+1];
				c3 = buf[2 + x * 3+2];
				if(c1 == ' ')continue;
				if(c1 == '+')sign =+1;
				if(c1 == '-')sign = -1;
				for(int i = 0;i < 14;i++){
					if(c2 == name[i][0] && c3 == name[i][1])
						out.kifu[x + y * 9] = sign*(1 + i);
				}
				if(c2 == 'O'){
					if(sign == +1)out.king_pos[0] = x + y * 9;
					if(sign == -1)out.king_pos[1] = x + y * 9;
				}
			}
		}

		while(fgets(buf, 1024, fp)){
			int player = -1;
			if(buf[1] == '+')player =  0;
			if(buf[1] == '-')player =  1;
			if(player == -1)
				break;
			char c1, c2;
			for(int i = 2;i < strlen(buf)-1;i+=4){
				c1 = buf[i+2];
				c2 = buf[i+3];
				if(c1 == 'F' && c2 == 'U')
					out.kifu[81 + player * 7]++;
				if(c1 == 'K' && c2 == 'Y')
					out.kifu[82 + player * 7]++;
				if(c1 == 'K' && c2 == 'E')
					out.kifu[83 + player * 7]++;
				if(c1 == 'G' && c2 == 'I')
					out.kifu[84 + player * 7]++;
				if(c1 == 'K' && c2 == 'I')
					out.kifu[85 + player * 7]++;
				if(c1 == 'K' && c2 == 'A')
					out.kifu[86 + player * 7]++;
				if(c1 == 'H' && c2 == 'I')
					out.kifu[87 + player * 7]++;
			}
		}

		fclose(fp);
	}
}



void conv2te(int x1, int y1, int x2, int y2, int nari, int & te)
{
	int from, to;
	if(y1 == -1)
	{
		from = 80 + (x1 + 1);
	} else {
		from = x1 + y1 * 9;
	};

	to = x2 + y2 * 9;

	te = (nari << 14) + (from << 7) + to;
}

struct kifu_t
{
	int num;
	int *te;
};

void conv(char *txt, kifu_t & out){
	char nari[6][4]={"TO","NY","NK","NG", "UM","RY" };
	char koma[8][4] = {"FU","KY","KE","GI","KI","KA","HI","OU"};
	int i, j, num;
	int px1[1500];
	int py1[1500];
	int px2[1500];
	int py2[1500];
	int fl[1500];

	num = 0;
	int len =  strlen(txt);
	for(i = 0;i <= len; i+= 6)
	{
		int x1, y1, x2, y2, n;
		x1 = txt[i  ] -'1';
		y1 = txt[i+1] -'1';
		x2 = txt[i+2] -'1';
		y2 = txt[i+3] -'1';
		// u
		if(x1 == -1 && y1 == -1)
		{
			y1 = -1;
			for(j = 0;j < 8;j++)
			{
				if(strncmp(&txt[i+4], koma[j],2)==0)
				{
					x1 = j;
					break;
				};//fi
			};// j
		} else {
			x1 = 8 - x1;
		}
		x2 = 8 - x2;
		// ȂH
		n = 0;
		for(j = 0;j < 6;j++)
		{
			if(strncmp(&txt[i+4], nari[j],2)==0)
			{
				n = 1;
				break;
			};//fi
		};// j
		px1[num] = x1;
		py1[num] = y1;
		px2[num] = x2;
		py2[num] = y2;
		fl[num]  = n;
		num++;
	};

	num--;
	out.num = num;
	out.te  = new int[num];
	for(i = 0;i < num;i++)
	{
		conv2te(
			px1[i], 
			py1[i], 
			px2[i], 
			py2[i], 
			fl[i], 
			out.te[i]);
	}
};

int load_suzi(char *filename, char * suzi){

	int player = 0;
	suzi[0] = 0;
	FILE *fp=fopen(filename, "r");
	if(fp){
		char buf[1024];
		char buf2[1024];
		char *line;
		char *pbuf;

		while(fgets(buf, 1024, fp)){

			if(strstr(buf, "pruning")||strstr(buf, "hashing"))
				break;
			if(strstr(buf, "  8  ")){
				pbuf = buf;
				for(int n = 1;n <= 15;n++){
					char t[256];
					sprintf(t, "%d.", n);
					line = strstr(pbuf, t);
					if(!line){
						fgets(buf, 1024, fp);
						pbuf = buf;
						line = strstr(pbuf, t);
					}
					if(!line)
						continue;
					if(n == 1){
						if(line[2]=='+')
							player = 0;
						if(line[2]=='-')
							player = 1;
					}
					if(n < 10){
					strncat(suzi, &line[3], 6);
					pbuf = &line[6];
					}
					else {
					strncat(suzi, &line[4], 6);
					pbuf = &line[6];
					}
				}
			}

		}
		fclose(fp);
	}
	return player;
}

int main(int argc, char *argv[]){

	if(argc == 2){
		mode = atoi(argv[1]);
	}
	// |[g쐬
	rfp=fopen("./report.html", "w");
	fprintf(rfp, "<HTML><BODY>");

	//
	load_fv("./fv.bin");
	
	system("del /Q log");
	system("bonanza.exe");
	


	kyokumen_t root;
	load_csa("./log/game000.csa", root);
	print_kifu(root.kifu);

	char suzi[1024];
	int player = load_suzi("./log/n000.log", suzi);
	kifu_t pv;
	conv(suzi, pv);

	IplImage *pimg;
	pimg   = cvCreateImage(cvSize(640,640), IPL_DEPTH_8U, 3);	
	draw_kifu(root.kifu, pimg);
	cvSaveImage("./log/init.png", pimg);

	fprintf(rfp, "͋ǖ->[ǖ<br><img src=./log/init.png width=320>  ");
	fprintf(rfp, "<img src=./log/leaf.png width=320><br>");
	fprintf(rfp, "PV=");
	printf("\nPV=");
	for(int i = 0;i < pv.num;i++){
		if(player == 0){
			printf("+%c%c%c%c%c%c\n", suzi[i*6+0],suzi[i*6+1],suzi[i*6+2],suzi[i*6+3],suzi[i*6+4],suzi[i*6+5]);
			fprintf(rfp, "+%c%c%c%c%c%c\n", suzi[i*6+0],suzi[i*6+1],suzi[i*6+2],suzi[i*6+3],suzi[i*6+4],suzi[i*6+5]);
		} else {
			printf("-%c%c%c%c%c%c\n", suzi[i*6+0],suzi[i*6+1],suzi[i*6+2],suzi[i*6+3],suzi[i*6+4],suzi[i*6+5]);
			fprintf(rfp, "-%c%c%c%c%c%c\n", suzi[i*6+0],suzi[i*6+1],suzi[i*6+2],suzi[i*6+3],suzi[i*6+4],suzi[i*6+5]);
		}
		make_move(player, &root, pv.te[i]);
		player = 1 - player;
		//print_kifu(root.kifu);
	}
	printf("\n\n");
	fprintf(rfp, "<br><br>");
	print_kifu(root.kifu);

	//
	int v = evaluate_pos(root, 0);
	fprintf(rfp, "evaluation value (material+position)=%+d<br><br>", v);
	fprintf(rfp, "material=%+d<br>", material(root));

	for(int i = 0;i < rank_num;i++){
		fprintf(rfp, "<img src=./log/rank%03d.png width=320> ", i+1, i + 1);
		if(i%5==4)
		fprintf(rfp, "<br><br>");
	}
	fprintf(rfp, "</BODY></HTML>");
	fclose(rfp);

	return 0;
}

